class AuthProfile {
  final String userId;
  final String? email;
  final String? name;
  final String? pictureUrl;

  AuthProfile({
    required this.userId,
    this.email,
    this.name,
    this.pictureUrl,
  });

  factory AuthProfile.fromJson(Map<String, dynamic> json) => AuthProfile(
        userId: json["sub"],
        email: json["email"],
        name: json["name"],
        pictureUrl: json["picture"],
      );

  AuthProfile copyWith({
    String? email,
    String? name,
    String? pictureUrl,
  }) {
    return AuthProfile(
      userId: userId,
      email: email ?? this.email,
      name: name ?? this.name,
      pictureUrl: pictureUrl ?? this.pictureUrl,
    );
  }
}
