import 'auth_profile.dart';
import 'auth_token.dart';

class AuthUserModel {
  final AuthToken authToken;
  final AuthProfile profile;
  final String hashedUserId;
  final String accountType;

  AuthUserModel({
    required this.authToken,
    required this.profile,
    required this.hashedUserId,
    required this.accountType,
  });

  AuthUserModel copyWith({
    AuthToken? authToken,
    AuthProfile? profile,
    String? hashedUserId,
    String? accountType,
  }) {
    return AuthUserModel(
      authToken: authToken ?? this.authToken,
      profile: profile ?? this.profile,
      hashedUserId: hashedUserId ?? this.hashedUserId,
      accountType: accountType ?? this.accountType,
    );
  }
}

extension AuthUserModelExtensions on AuthUserModel {
  bool get isPersonal => accountType == "FSBO";
}
