import 'dart:async';

import 'package:flutter/foundation.dart';
import 'package:get_it/get_it.dart';

class Injector {
  static final _locator = GetIt.instance;

  static void registerLazySingleton<T extends Object>(
    T Function() factoryFunc, {
    String? instanceName,
    FutureOr Function(T param)? dispose,
  }) {
    _locator.registerLazySingleton<T>(
      factoryFunc,
      instanceName: instanceName,
      dispose: dispose,
    );
  }

  static void registerFactory<T extends Object>(
    T Function() factoryFunc, {
    String? instanceName,
  }) {
    _locator.registerFactory<T>(factoryFunc, instanceName: instanceName);
  }

  static T get<T extends Object>({dynamic param1, dynamic param2}) => _locator.get(param1: param1, param2: param2);

  static bool isRegistered<T extends Object>() => _locator.isRegistered<T>();

  /// Clears the registered types in the DI Container. Should only be used in unit tests
  @visibleForTesting
  static Future reset() => _locator.reset();
}
