abstract class PositionResponse {}

class SuccessfulPositionResponse extends PositionResponse {
  final Position position;

  SuccessfulPositionResponse({
    required this.position,
  });
}

class FailedPositionResponse extends PositionResponse {
  final PositionError error;

  FailedPositionResponse({
    required this.error,
  });
}

class Position {
  final double longitude;
  final double latitude;
  final DateTime? timestamp;
  final double accuracy;
  Position({
    required this.longitude,
    required this.latitude,
    this.timestamp,
    required this.accuracy,
  });
}

enum PositionError {
  servicesDisabled,
  permissionDenied,
  notFound,
  unknown,
}
