// coverage:ignore-file
class MetricsConstants {
  static _PageFields pageFields = _PageFields();
  static _UserFields userFields = _UserFields();
  static _DeviceFields deviceFields = _DeviceFields();
  static _LoginConstants login = _LoginConstants();
  static _ErrorConstants error = _ErrorConstants();
  static _RegistrationConstants registration = _RegistrationConstants();
  static _ForgotPasswordConstants forgotPassword = _ForgotPasswordConstants();
  static _ChangePasswordConstants changePassword = _ChangePasswordConstants();
  static _CategoryConstants category = _CategoryConstants();
  static _ProfileConstants profile = _ProfileConstants();
  static _CommonConstants common = _CommonConstants();
  static _VipConstants vip = _VipConstants();
  static _ChatConstants chat = _ChatConstants();
  static _HomePageConstants homepage = _HomePageConstants();
  static _FavouritesConstants favourites = _FavouritesConstants();
  static _MyAdsConstants myAds = _MyAdsConstants();
  static _Search search = _Search();
  static _PostConstants post = _PostConstants();
  static _NotificationCentreConstants notification = _NotificationCentreConstants();
  static _PromotionConstants promotion = _PromotionConstants();
  static _CheckoutConstants checkout = _CheckoutConstants();
}

class _CommonConstants {
  final String cta = "cta";
  final String eventLabel = "event_label";

  final String screenViewLabel = "screen_view";
  final String screenNameLabel = "screen_name";
}

class _PageFields {
  static const String prefix = "p";
  static const String categoryPrefix = "c";
  static const String searchPrefix = "s";
  static const String filter = "f";
  static const String sortPrefix = "srt";
  static const String pricePrefix = "prc";
  static const String locationPrefix = "l";
  final String type = "t".build(prefix);
  final String language = "lng".build(prefix);
  final String categoryIdKey = "id".build(categoryPrefix).build(categoryPrefix);
  final String categoryIdName = "n".build(categoryPrefix).build(categoryPrefix);
  final String locationId = "id".build(locationPrefix).build(categoryPrefix);
  final String radius = "r".build(locationPrefix);
  final String keyword = "kw".build(searchPrefix);
  final String limit = "ps".build(searchPrefix);
  final String sort = filter.build(sortPrefix).build(searchPrefix);
  final String totalCount = "tr".build(searchPrefix);
  final String pageNumber = "pn".build(searchPrefix);
  final String totalPage = "tp".build(searchPrefix);
  final String minPrice = "mn".build(pricePrefix).build(searchPrefix);
  final String maxPrice = "mx".build(pricePrefix).build(searchPrefix);
  String categoryIdLevelPrefix(int level) => "id".build("cat").build("l$level").build("ad");
  String categoryNameLevelPrefix(int level) => "name".build("cat").build("l$level").build("ad");
}

class _UserFields {
  static const String prefix = "u";
  final String loggedIn = "li".build(prefix);
  final String hashedUserId = "huid".build(prefix);
  final String accountType = "at".build(prefix);
}

class _DeviceFields {
  static const String prefix = "d";
  final String clientId = "ck".build(prefix);
  final String userAgent = "ua".build(prefix);
}

class _Search {
  final String searchPageType = "Search";
  final String homeagePageType = "Homepage";
  final String homeageErrorPageType = "HomepageError";
  final String searchResultPageType = "ResultSearch";
  final String browsePageType = "Browse";
  final String browseResultPageType = "ResultBrowse";
  final String actionSearchAttempt = "SearchAttempt";
  final String browseB = "browse_b";
  final String searchKey = "searchKey";
  final String keywordSearchB = "keywordSearch_b";
  final String freq = "freq";
  static const String searchPrefix = "s";
  static const String attrPrefix = "attr";

  final String actionFilterSelectReset = "FilterSelectReset";
  final String actionFilterSelectBegin = "FilterSelectBegin";
  final String actionFilterSelectAttempt = "FilterSelectAttempt";
  final String actionFilterSelectCancel = "FilterSelectCancel";
  final String actionFilterSelectSuccess = "FilterSelectSuccess";
  final String actionFilterSelectFail = "FilterSelectFail";

  final String actionCategorySelectBegin = "CategorySelectBegin";
  final String actionCategorySelectAttempt = "CategorySelectAttempt";
  final String actionCategorySelectSuccess = "CategorySelectSuccess";
  final String actionCategorySelectFail = "CategorySelectFail";

  final String actionSavedSearchAddBegin = "SavedSearchAddBegin";
  final String actionSavedSearchAddCancel = "SavedSearchAddCancel";
  final String actionSavedSearchAddAttempt = "SavedSearchAddAttempt";
  final String actionSavedSearchAddSuccess = "SavedSearchAddSuccess";
  final String actionSavedSearchAddFail = "SavedSearchAddFail";

  final String actionSavedSearchDeleteAttempt = "SavedSearchDeleteAttempt";
  final String actionSavedSearchDeleteSuccess = "SavedSearchDeleteSuccess";
  final String actionSavedSearchDeleteFail = "SavedSearchDeleteFail";

  final String addressLabel = "address";
  final String radialSearchBLabel = "radialSearch_b";
  final String distanceLabel = "distance";

  final String actionLocationSelectBegin = "LocationSelectBegin";
  final String actionLocationSelectAttempt = "LocationSelectAttempt";
  final String actionLocationSelectCancel = "LocationSelectCancel";
  final String actionLocationSelectSuccess = "LocationSelectSuccess";
  final String actionLocationSelectFail = "LocationSelectFail";

  final String actionSearchBegin = "SearchBegin";
  final String typeLabelKey = "type";
  final String keywordLabelKey = "keyword";
  final String organicKeyword = "organic_keyword";
  final String autoSuggestKeyword = "auto_suggest_keyword";
  final String autoSuggestCat = "auto_suggest_cat";

  String appendAttrPrefix(String key) {
    return key.build(attrPrefix).build(searchPrefix);
  }
}

class _CategoryConstants {
  final String id = "id";
  final String name = "n";
  final String noCategory = "Classifieds";
}

class _FavouritesConstants {
  final String pageType = "Watchlist";
  final String savedSearchPageType = "SavedSearchList";
  final String actionSavedSearchDeleteAttempt = "SavedSearchDeleteAttempt";
  final String actionSavedSearchDeleteFail = "SavedSearchDeleteFail";
  final String actionSavedSearchDeleteSuccess = "SavedSearchDeleteSuccess";
  final String actionSavedSearchView = "SavedSearchView";

  final String actionWatchlistFail = "WatchlistFail";
  final String actionWatchlistRemove = "WatchlistRemove";
}

class _VipConstants {
  static const String messagePrefix = "m";
  final String pageType = "VIP";
  final String sVipPageType = "SVIP";
  final String conversationId = "cid".build(messagePrefix);

  final String actionWatchlistAdd = "WatchlistAdd";
  final String actionWatchlistRemove = "WatchlistRemove";
  final String actionWatchlistView = "WatchlistView";
  final String actionWatchlistRemoveFail = "WatchlistRemoveFail";

  final String actionR2SChatBegin = "R2SChatBegin";
  final String actionR2SChatAttempt = "R2SChatAttempt";
  final String actionR2SChatSuccess = "R2SChatSuccess";
  final String actionR2SChatFail = "R2SChatFail";

  final String actionPhoneBegin = "R2SPhoneBegin";
  final String actionPhoneCancel = "R2SPhoneCancel";
  final String actionPhoneAttempt = "R2SPhoneAttempt";

  final String actionR2SEmailBegin = "R2SEmailBegin";
  final String actionR2SEmailAttempt = "R2SEmailAttempt";
  final String actionR2SEmailSuccess = "R2SEmailSuccess";
  final String actionR2SEmailFail = "R2SEmailFail";
  final String actionViewReprt = "CarProofRequestSuccess";

  final String actionR2SExternalBegin = "R2SExternalBegin";

  final String actionEditAdBegin = "EditAdBegin";

  final String actionViewVideoBegin = "ViewVideoBegin";
  final String actionViewImageBegin = "ViewImagesBegin";
  final String actionViewImageSwipe = "ViewImagesSwipe";
  final String actionViewImageClose = "ViewImagesClose";

  final String actionReportAdBegin = "ReportAdBegin";
  final String actionReportAdAttempt = "ReportAdAttempt";
  final String actionReportAdSuccess = "ReportAdSuccess";
  final String actionReportAdFail = "ReportAdFail";

  final String customLabelType = "type";
  final String actionViewMapBegin = "ViewMapBegin";
  final String actionViewMapAttempt = "ViewMapAttempt";

  final String reasonKey = "reason";
  final String selectionKey = "selection";
  final String positionKey = "position";

  final String actionChipScrollSelect = "ChipScrollSelect";

  static const String locationPrefix = "l";
  static const String categoryPrefix = "c";
  static const String userPrefix = "u";
  static const String l1Prefix = "l1";
  static const String l2Prefix = "l2";
  static const String l3Prefix = "l3";
  static const String adPrefix = "a";
  static const String pricePrefix = "prc";

  final String locationId = "id".build(categoryPrefix).build(locationPrefix);
  final String latLongCoordinate = "ltlng".build(locationPrefix);
  final String adId = "id".build(adPrefix);
  final String adImgCount = "ic".build(adPrefix);
  final String adDescriptionLength = "dl".build(adPrefix);
  final String adPriceAmount = "amt".build(pricePrefix).build(adPrefix); //   "a.prc.amt = $ad_price_amount
  final String adPriceCurrency = "cur".build(pricePrefix).build(adPrefix); // a.prc.cur = $ad_price_currency (CAD)
  final String adPriceType = "t".build(pricePrefix).build(adPrefix); // a.prc.t = $ad_price_type (e.g. free, exact, etc.)"
  final String adSellerAccountType = "at".build(userPrefix).build(adPrefix); // a.u.at = $seller_account_type
  String dataParamCurrentCategoryId(level) => "id".build("l$level").build(categoryPrefix);
  String dataParamCurrentCategoryName(level) => "n".build("l$level").build(categoryPrefix);
}

class _HomePageConstants {
  final String pageTypeHomepage = "Homepage";
  final String actionSearchOpen = "SearchOpen";
  final String actionMessageCenterOpen = "MessageCenterOpen";
  final String actionMyAccountOpen = "MyAccountOpen";
  final String actionMyAdsOpen = "MyAdsOpen";
  final String actionPostAdBegin = "PostAdBegin";
  final String actionWatchlistOpen = "WatchlistOpen";
  final String actionBrowseAttempt = "BrowseAttempt";
  final String actionBrowseBack = "BrowseBack";
  final String actionNotificationCentreOpen = "NotificationCentreOpen";
  final String ctaNavbar = "navbar";
  final String ctaHeader = "header";
}

class _ChatConstants {
  static const String messagePrefix = "m";
  final String conversationId = "cid".build(messagePrefix);
  final String pageTypeMessageCenter = "MessageCenter";
  final String pageTypeMessageCenterError = "MessageCenterError";
  final String pageTypAdConversation = "AdConversation";

  final String actionB2SChatSuccess = "B2SChatSuccess";
  final String actionS2BChatSuccess = "S2BChatSuccess";
  final String actionB2SChatFail = "B2SChatFail";
  final String actionS2BChatFail = "S2BChatFail";

  final String blockUserCta = "block_user";
  final String replyBackCta = "reply_back";
  final String deleteMsgCta = "delete_message";

  final String actionUserRegistrationBegin = "UserRegistrationBegin";
  final String actionMessageOptionsBegin = "MessageOptionsBegin";
  final String actionMessageOptionsAttempt = "MessageOptionsAttempt";
  final String actionMessageOptionsCancel = "MessageOptionsCancel";
  final String actionMessageOptionsSuccess = "MessageOptionsSuccess";
  final String actionMessageOptionsFail = "MessageOptionsFail";
  final String actionUnread = "unread";
}

class _LoginConstants {
  final String pageType = "Login";
  final String actionLoginBegin = "LoginBegin";
  final String actionLoginCancel = "LoginCancel";
  final String actionLoginAttempt = "LoginAttempt";
  final String actionLoginSuccess = "LoginSuccess";
  final String actionLoginFail = "LoginFail";
}

class _ProfileConstants {
  final String pageType = "MyAccount";
  final String profileErrorPage = "MyAccountError";
  final String myReviewsPageType = "MyReview";
  final String favouritesPageType = "MyWatchlist";

  final String addProfilePageType = "MyAccountAddProfilePicture";
  final String actionUserRegistrationBegin = "UserRegistrationBegin";
  final String actionLogoutSuccess = "LogoutSuccess";

  final String personalDetailsComponentType = "PersonalDetails";
  final String businessDetailsComponentType = "BusinessInformation";

  final String socialMediaPageType = "MyAccountSocialMediaLinks";
  final String socialMediaComponentType = "SocialMediaLinks";
  final String businessInfoComponentType = "MyAccountBusinessInformation";
  final String manageAccountComponentType = "MyAccountManageAccount";
  final String notificationPreferencesComponentType = "MyAccountNotificationPreference";
  final String termsOfUseComponentType = "MyAccountTermsOfUse";
  final String privacyPolicyComponentType = "MyAccountPrivacyPolicy";
  final String helpComponentType = "MyAccountHelp";

  final String personalInformationPageType = "MyAccountPersonalInformation";
  final String businessInformationPageType = "MyAccountBusinessInformation";
  final String actionMyAccountUpdateSuccess = "MyAccountUpdateSuccess";
  final String actionMyAccountUpdateCancel = "MyAccountUpdateCancel";
  final String actionMyAccountUpdateAttempt = "MyAccountUpdateAttempt";
  final String actionMyAccountUpdateBegin = "MyAccountUpdateBegin";
  final String actionMyAccountUpdateFail = "MyAccountUpdateFail";

  final String actionAddProfilePictureBegin = "AddProfilePictureBegin";
  final String actionAddProfilePictureAttempt = "AddProfilePictureAttempt";
  final String actionAddProfilePictureSuccess = "AddProfilePictureSuccess";
  final String actionAddProfilePictureFail = "AddProfilePictureFail";
  final String addPictureProfileCta = "profile"; //TODO: Verify what this should be, and where it should come from

  final String eventLabelBusinessName = "BusinessName";
  final String eventLabelBusinessWebsite = "BusinessWebsite";
  final String eventLabelFields = "fields";
  final String eventLabelPersonalFullName = "FullName";
  final String eventLabelPersonalEmail = "Email";
  final String eventLabelPersonalPassword = "Password";
  final String eventLabelSocialFacebook = "Facebook";
  final String eventLabelSocialInstagram = "Instagram";
  final String eventLabelSocialTwitter = "Twitter";
  final String eventLabelSocialYoutube = "Youtube";
  final String eventLabelSocialTikTok = "TikTok";
  final String eventLabelSocialPinterest = "Pinterest";
  final String eventLabelSocialLinkedIn = "LinkedIn";
}

class _PostConstants {
  static const locationPrefix = "l";
  static const categoryPrefix = "c";
  static const namePrefix = "n";
  static const idPrefix = "id";

  final String pageTypePostAdCategory = "PostAdCategory";
  final String pageTypePostAd = "PostAd";
  final String pagePostAdSuccess = "PostAdSuccess";
  final String pageTypeEditAd = "EditAd";
  final String actionFeatureAdBegin = "FeatureAdBegin";
  final String eventLabelInput = "input";
  final String eventLabelL1Cat = "L1cat";
  final String eventLabelCat = "cat";

  final String eventLabelAdType = "t".build("a");
  final String eventLabelAdTypeOffer = "OFFER";
  final String eventLabelAdTypeWanted = "WANTED";
  final String eventLabelAttr = "attr";
  final String eventLabelCatSuggested = "catSuggested";
  final String eventLabelVideoLink = "videolink";
  final String eventLabelSelections = "selectins";
  final String eventLabelListingFee = "listing_fee";

  final String actionPostAdFieldInput = "PostAdFieldInput";
  final String actionManualVinBegin = "ManualVinBegin";
  final String actionPostAdNotificationShow = "PostAdNotificationShow";
  final String actionPostAdNotificationCancel = "PostAdNotificationCancel";
  final String actionPostAdNotificationClick = "PostAdNotificationClick";
  final String actionPostAdFreeAttempt = "PostAdFreeAttempt";
  final String actionPostAdPaidAttempt = "PostAdPaidAttempt";
  final String actionPostAdCancel = "PostAdCancel";
  final String actionPostAdFreeSuccess = "PostAdFreeSuccess";
  final String actionPostAdPaidSuccess = "PostAdPaidSuccess";
  final String actionEditAdCancel = "EditAdCancel";
  final String actionEditAdAttempt = "EditAdAttempt";
  final String actionEditAdSuccess = "EditAdSuccess";
  final String actionEditAdFail = "EditAdFail";
  final String actionPostAdPaidFail = "PostAdPaidFail";
  final String actionPostAdFreeFail = "PostAdFreeFail";
  final String dataParamLeafCategoryId = idPrefix.build(categoryPrefix).build(categoryPrefix);
  final String dataParamLeafCategoryName = namePrefix.build(categoryPrefix).build(categoryPrefix);
  String dataParamCurrentCategoryId(level) => idPrefix.build("l$level").build(categoryPrefix);
  String dataParamCurrentCategoryName(level) => namePrefix.build("l$level").build(categoryPrefix);
  final String dataParamAdId = idPrefix.build("a");
  final String ctaListingFee = "listing_fee";
  final String pageType = "PostAd";
  //Image
  final String actionAddImageBegin = "AddImageBegin";
  final String actionAddImageAttempt = "AddImageAttempt";
  final String actionAddImageCancel = "AddImageCancel";
  final String actionAddImageSuccess = "AddImageSuccess";
  final String actionAddImageFail = "AddImageFail";
  //Location
  final String actionPostAdLocationAttempt = "PostAdLocationAttempt";
  final String actionPostAdLocationSuccess = "PostAdLocationSuccess";
  final String actionPostAdLocationFail = "PostAdLocationFail";

  final String dataParamlocationId = "id".build(categoryPrefix).build(locationPrefix);
  final String dataParamlocationName = namePrefix.build(categoryPrefix).build(locationPrefix);
  final String dataParamlocationPostalCode = "pcid".build(locationPrefix);
  final String dataParamlocationLatLng = "ltlng".build(locationPrefix);
}

class _RegistrationConstants {
  final String pageTypeUserRegistration = "UserRegistrationLandingPage";
  final String pageTypeUserRegistrationForm = "UserRegistrationForm";
  final String pageTypeUserRegistrationRedirectedBusinessPersonal = "UserRegistrationForm";
  final String pageTypeUserActivation = "UserActivationPage";

  final String actionLoginBegin = "LoginBegin";
  final String actionUserRegistrationBegin = "UserRegistrationBegin";
  final String actionUserActivationSuccess = "UserActivationSuccess";
  final String actionUserActivationFail = "UserActivationFail";

  final String actionUserRegistrationSuccess = "UserRegistrationSuccess";
  final String actionUserRegistrationFail = "UserRegistrationFail";
  final String actionUserRegistrationAttempt = "UserRegistrationAttempt";
}

class _ForgotPasswordConstants {
  final String pageType = "PasswordForgotten";
  final String actionPasswordResetBegin = "PasswordResetBegin";
  final String actionPasswordResetSent = "PasswordResetSent";
}

class _ChangePasswordConstants {
  final String pageType = "PasswordResetForm";
  final String actionChangePasswordResetAttempt = "PasswordResetAttempt";
  final String actionChangePasswordResetSuccess = "PasswordResetSuccess";
  final String actionChangePasswordResetFail = "PasswordResetFail";
}

class _MyAdsConstants {
  final String pageTypeActive = "MyAdsActive";
  final String pageTypeInactive = "MyAdsInactive";
  final String pageTypeInsights = "StatsAd";

  final String actionLoginBegin = "LoginBegin";
  final String actionUserRegistrationBegin = "UserRegistrationBegin";

  final String actionDeleteAdBegin = "DeleteAdBegin";
  final String actionDeleteAdCancel = "DeleteAdCancel";
  final String actionDeleteAdAttempt = "DeleteAdAttempt";
  final String actionDeleteAdSuccess = "DeleteAdSuccess";
  final String actionDeleteAdFail = "DeleteAdFail";

  final String actionEditAdBegin = "EditAdBegin";
  final String actionInsightsLoadFail = "StatsAdLoadFail";
  final String actionPromoteAdBegin = "FeatureAdBegin";

  final String actionRepostAdAttempt = "RepostAdAttempt";
  final String actionRepostAdFreeSuccess = "RepostAdFreeSuccess";
  final String actionRepostAdPaidAttempt = "RepostAdPaidAttempt";
  final String actionRepostAdPaidSuccess = "RepostAdPaidSuccess";
  final String actionRepostAdPaidFail = "RepostAdPaidFail";
  final String actionRepostAdFail = "RepostAdFail";

  final String ctaPromote = "promote";

  final String customLabelAdId = "adId";
}

class _NotificationCentreConstants {
  final String pageType = "NotificationCentre";
  final String filterSelectAction = "NotificationFilterSelect";
  final String filterEventLabel = "filter";
  final String actionNotificationOptionBegin = "NotificationOptionsBegin";
  final String actionNotificationOptionAttempt = "NotificationOptionsAttempt";
  final String actionNotificattionOptionCancel = "NotificationOptionsCancel";
  final String actionNotificationOptionSuccess = "NotificationOptionsSuccess";
  final String actionNotificationOptionFail = "NotificationOptionsFail";
  final String actionUnread = "unread";
}

class _PromotionConstants {
  final String pageTypeOrderForm = "OrderForm";
  final String pageTypeViewFeatures = "ViewFeatures";
  final String pageTypeOrderHistory = "OrderHistory";
  final String pageTypeOrderDetails = "OrderDetails";
  final String actionFeatureAdBegin = "FeatureAdBegin";
  //Data parameters
  static const String orderPrefix = "o";
  final String dataParamOrderId = "id".build(orderPrefix).build(orderPrefix);
  final String dataParamOrderStatus = "sts".build(orderPrefix);
  final String dataParamTotalNumberOfItems = "ti".build(orderPrefix);
  final String dataParamSource = "src".build(orderPrefix);
  final String dataParamTotalNetAmount = "tna".build(orderPrefix);
  final String dataParamTotalTaxAmount = "ttx".build(orderPrefix);
  final String dataParamCurrency = "cur".build(orderPrefix);
}

class _CheckoutConstants {
  final String customLabelAdId = "adId";
  final String customLabelCTA = "cta";
  final String customLabelFeatureNames = "ftr";
  static const String billingPrefix = "b";
  final String customLabelSaveAsDefaultBillingAddress = billingPrefix.build("saved");
  final String pageTypeOrderReview = "OrderReview";
  final String pageTypeOrderConfirm = "OrderConfirm";
  final String pageTypeOrderSuccess = "OrderSuccess";
  final String actionFeatureBillingAddressBegin = "FeatureBillingAddressBegin";
  final String actionFeatureBillingAddressCancel = "FeatureBillingAddressCancel";
  final String actionFeatureBillingAddressAttempt = "FeatureBillingAddressAttempt";
  final String actionFeatureBillingAddressSuccess = "FeatureBillingAddressSuccess";
  final String actionFeatureBillingAddressFail = "FeatureBillingAddressFail";
  final String actionFeatureAdAttempt = "FeatureAdAttempt";
  final String actionFeatureAdSuccess = "FeatureAdSuccess";
  final String actionFeatureAdFail = "FeatureAdFail";
  final String actionPostAdPaidSuccess = "PostAdPaidSuccess";
  final String actionFeatureAdEdit = "FeatureAdEdit";
  final String actionFeatureAdRemove = "FeatureAdRemove";
  final String actionFeatureAdClear = "FeatureAdClear";
  final String actionFeatureAdCancel = "FeatureAdCancel";
}

class _ErrorConstants {
  final String type = "error_type";
  final String message = "error";
}

enum MetricsErrorSource {
  /// Front-end
  fe,

  /// Back-end
  be,
}

extension _FieldBuilderExtensions on String {
  static const String separator = "_";
  String build(String prefix) {
    return [prefix, this].join(separator);
  }
}
