import 'package:dio/dio.dart';

enum NetworkResponseType { json, stream, plain, bytes }

extension NetworkResponseTypeExtension on NetworkResponseType {
  ResponseType get getType {
    switch (this) {
      case NetworkResponseType.bytes:
        return ResponseType.bytes;
      case NetworkResponseType.json:
        return ResponseType.json;
      case NetworkResponseType.plain:
        return ResponseType.plain;
      case NetworkResponseType.stream:
        return ResponseType.stream;
    }
  }
}
