import 'package:dio/dio.dart';

import '../enums/network_error.dart';

extension DioToNetworkErrorExtensions on DioErrorType {
  NetworkError toNetworkError() {
    switch (this) {
      case DioErrorType.connectTimeout:
      case DioErrorType.sendTimeout:
      case DioErrorType.receiveTimeout:
        return NetworkError.timeout;
      case DioErrorType.response:
        return NetworkError.status;
      case DioErrorType.cancel:
        return NetworkError.cancel;
      case DioErrorType.other:
        return NetworkError.unknown;
    }
  }
}
