import 'package:dio/dio.dart';

import '../../../logging.dart';

class BaseInterceptor extends InterceptorsWrapper {
  final ErrorTracker errorTracker;
  BaseInterceptor({
    required this.errorTracker,
  });

  @override
  void onError(DioError err, ErrorInterceptorHandler handler) async {
    var statusCode = err.response?.statusCode;
    if (statusCode == null || statusCode >= 500 && statusCode < 600) {
      await errorTracker.recordError(
        err.error,
        err.stackTrace,
        reason: err.message,
      );
    }
    super.onError(err, handler);
  }
}
