//coverage:ignore-file

import 'enums/notification_authorization.dart';
import 'models/notification_payload.dart';

abstract class NotificationService {
  Future<NotificationAuthorization> requestPermission();
  Future<NotificationAuthorization> checkPermission();
  Future<NotificationPayload?> getInitialMessage();
  Stream<NotificationPayload> get onMessage;
  Stream<NotificationPayload> get onMessageOpened;
  Future<String?> getToken();
  Future<void> deleteToken();
  Stream<String?> get onTokenRefresh;
}
