import 'package:flutter/material.dart';
import 'package:package_info_plus/package_info_plus.dart';

class PlatformService {
  late String _appVersion;
  late String _appName;
  late String _packageName;

  PlatformService() {
    PackageInfo.fromPlatform().then(
      (value) {
        _appVersion = value.version;
        _appName = value.appName;
        _packageName = value.packageName;
      },
    );
  }

  String get appVersion => _appVersion;

  String get appName => _appName;

  String get packageName => _packageName;

  @visibleForTesting
  static void setMockInitialValues({
    String appName = "SaiMobileApps",
    String packageName = "com.saimobileapps",
    String version = "42",
    String buildNumber = "123",
    String buildSignature = "xyz",
  }) {
    PackageInfo.setMockInitialValues(
      appName: appName,
      packageName: packageName,
      version: version,
      buildNumber: buildNumber,
      buildSignature: buildSignature,
    );
  }
}
